<?
  function control_test($testId)
  {
    $db = Database::get_instance();

    $test = $db->get_test_by_testId($testId);

    if ($test)
    {
      $title      = preg_replace('/</', '&lt;', $test['title']);
      $questions  = explode("\n", preg_replace('/</', '&lt;', $test['questions']));
      $answers    = explode("\n", preg_replace('/</', '&lt;', $test['answers']));
      $stylesheet = 'test';

      if (isset($_REQUEST['answers']))
        $user_answers = preg_replace('/</', '&lt;', $_REQUEST['answers']);

      foreach ($questions as $index => $question)
      {
        $test_questions[$index]['question'] = $questions[$index];
    
        if (isset($user_answers) && isset($user_answers[$index]))
        {
          $test_questions[$index]['user_answer'] = $user_answers[$index];
          $test_questions[$index]['is_correct'] =
            trim($user_answers[$index]) == trim($answers[$index]);
        }
        else
        {
          $test_questions[$index]['user_answer'] = '';
          $test_questions[$index]['is_correct'] = true;
        }
      }
      
      include 'view/header.php.html';
      include 'view/test.php.html';
      include 'view/footer.php.html';
    }
    else
    {
      control_error('Hittade inte testet!');
    }
  }
?>
