<?
  class Database
  {
    private $db;
    private static $instance = null;
      
    public static function get_instance()
    {
      if (self::$instance == null)
        self::$instance = new Database();
      
      return self::$instance;
    }
    
    private function Database()
    {
      $this->dbfile = 'database/database.csv';
    }
    
    function update_test($editId, $title, $questions, $answers)
    {
      $db = fopen($this->dbfile, 'r');
      
      $new_dbfile = tempnam('/tmp', 'testadb');
      $newdb = fopen($new_dbfile, 'a');
      
      while ($test = fgetcsv($db))
      {
        if ($test[0] == $editId)
          fputcsv($newdb, array($editId, $test[1], $title, $questions, $answers));
        else
          fputcsv($newdb, $test);
      }
      
      fclose($db);
      fclose($newdb);
      
      rename($new_dbfile, $this->dbfile);
    }
    
    function get_test_by_editId($id)
    {
      $db = fopen($this->dbfile, 'r');

      while (list($editId, $testId, $title, $questions, $answers) = fgetcsv($db))
      {
        if ($editId == $id)
        {
          $test = array('editId' => $editId,
                        'testId' => $testId,
                        'title' => $title,
                        'questions' => $questions,
                        'answers' => $answers);
          return $test;
        }
      }
    }
    
    function get_test_by_testId($id)
    {
      $db = fopen($this->dbfile, 'r');

      while (list($editId, $testId, $title, $questions, $answers) = fgetcsv($db))
      {
        if ($testId == $id)
        {
          $test = array('editId' => $editId,
                        'testId' => $testId,
                        'title' => $title,
                        'questions' => $questions,
                        'answers' => $answers);
          return $test;
        }
      }
    }
    
    function create_test()
    {
      do
      {
        $editId = rand(10000, 99999);
      } while ($this->get_test_by_editId($editId));
      
      do
      {
        $testId = rand(10000, 99999);
      } while ($this->get_test_by_testId($testId));

      $db = fopen($this->dbfile, 'a');
      fputcsv($db, array($editId, $testId, '', '', ''));
      
      return $editId;
    }
  }
?>
